## biosig4c++ 0.96.3+svn2677

=== Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id$
###  Copyright (C) 2006,2007,2008,2009,2010,2011 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


## make save2gdf   - makes converter
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mex        - mex4o and mex4m combined
## make libbiosig  - makes libbiosig
## make biosig4python - makes python interface (requires Python)
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make sigviewer  - makes sigviewer

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToMinGW   = $(HOME)/src/mingw-cross-env
PathToMinGW64 = $(HOME)/src/mce-w64

## default options

CC            = gcc
CXX           = g++
#DEFINES      = -D=WITHOUT_SCP_DECODE
DEFINES       = -D=HARDCODED_EVENTTABLE -D=WITH_ZLIB -D=__4HAERTEL__ -D=WITH_FAMOS -D=WITH_CHOLMOD #-D=WITH_FEF #-D=WITH_PDP -D=WITH_DICOM #-D=WITH_GDCM #-D=WITH_GSL #-D=WITH_EEPROBE #-D=SOFTCODED_PHYSDIMTABLE # if you have zlib
#DEFINES      += -D=CNT32
CFLAGS        = -pipe -fPIC -W -O2 $(DEFINES) -Wextra # -I cntopenlib/include/
CXXFLAGS      = -pipe -fPIC -W -O2 $(DEFINES) -Wextra # -I cntopenlib/include/
AR            = ar crs
INCPATH       = -I /usr/local/include/gdcm-2.0/
#		../gdcm-2.0.10/Source/DataStructureAndEncodingDefinition \
#		../gdcm-2.0.10/Source/InformationObjectDefinition  	\
#		../gdcm-2.0.10/Source/MediaStorageAndFileFormat 	\
#		../gdcm-2.0.10/Source/DataDictionary 			\
#		../gdcm-2.0.10/Source/Common
LINK          = $(CXX)
LFLAGS_dynamic = -L/usr/local/lib/ -L.
LIBS_dynamic  = -lbiosig
LFLAGS_static = -L/usr/local/lib/
LIBS_static   = libbiosig.a
ifeq ($(LIBEXT),so)
  LFLAGS      = $(LFLAGS_dynamic)
  LIBS        = $(LIBS_dynamic)
else
  LFLAGS      = $(LFLAGS_static)
  LIBS        = $(LIBS_static)
endif
ifneq (,$(findstring WITH_ZLIB, $(DEFINES)))
  LDLIBS     += -lcholmod
endif
ifneq (,$(findstring WITH_CHOLMOD, $(DEFINES)))
  LDLIBS     += -lz
endif
LIBS          += $(LDLIBS)

DELETE        = rm
COPY          = cp -f
TEMP_DIR      = /tmp/
libGDFobj     = $(patsubst %.cpp, %.o, $(shell ls -1 ../libgdf/libgdf/src/ |tr  '\n\r' ' '))
libGDFwin32obj     = $(patsubst %.cpp, win32/%.obj, $(shell ls -1 ../libgdf/libgdf/src/ |tr  '\n\r' ' '))

##########################################################
## set Matlab and Octave variables
ifneq ($(shell which matlab), )
  MATLABDIR  := $(dir $(shell readlink -f $(shell which matlab) ) )
  MEX         = $(MATLABDIR)mex
  MEX_EXT    := $(shell $(MATLABDIR)mexext)
endif

# Octave - global install  (e.g. from debian package)
OCTAVE_VERSION = 
INCOCTAVE = -I /usr/include/octave 
# Octave - local install (e.g. compiled from sources) 
OCTAVE_VERSION = -3.4.0
INCOCTAVE = -I /usr/local/include/octave$(OCTAVE_VERSION)/octave 
OCT           = mkoctfile$(OCTAVE_VERSION)
##########################################################

##########################################################
## set variables for Python
SWIG          = swig
PYTHONVER     = $(shell python -c "import sys; print sys.version[:3]")
##########################################################
 
##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
CROSS	     = i586-mingw32msvc-
CROSS	     = $(PathToMinGW)/usr/bin/i686-pc-mingw32-
MinGWCC      = $(CROSS)gcc
MinGWCXX     = $(CROSS)g++
MinGWDEF     = $(DEFINES)
MinGWCFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -I$(PathToMinGW)/usr/i686-pc-mingw32/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/usr/i686-pc-mingw32/lib/ -lws2_32 $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

CROSS64	     = $(PathToMinGW64)/usr/bin/x86_64-w64-mingw32-
MinGW64CC      = $(CROSS64)gcc
MinGW64CXX     = $(CROSS64)g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -I$(PathToMinGW64)/usr/x86_64-w64-mingw32/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/usr/x86_64-w64-mingw32/lib/ -lws2_32 $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig.h))
MINOR_VERSION := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig.h))
STEPPING      := $(word 3, $(shell grep '\#define BIOSIG_VERSION_STEPPING' biosig.h))
TODAY         := $(shell date +%Y%m%d)

####### Output directory

OBJ	      = ./obj
BIN	      = $(DESTDIR)/usr/bin
LIB	      = $(DESTDIR)/usr/lib

####### Files
SOURCES       = biosig.c \
		XMLParser/tinyxml.cpp \
		XMLParser/tinyxmlparser.cpp \
		XMLParser/tinyxmlerror.cpp \
		XMLParser/tinystr.cpp \
		t210/sopen_scp_read.c \
		t210/sopen_famos_read.c \
		t210/sopen_alpha_read.c \
		t210/scp-decode.cpp \
		t220/sopen_scp_write.c \
		t220/crc4scp.c \
		t230/sopen_hl7aecg.c \
		t240/sopen_fef_read.c \
		test0/sandbox.c \
		physicalunits.c \
		biosig-network.c \
		save2gdf.c \
		biosig_client.c \
		biosig_server.c

OBJECTS       = \
		crc4scp.o \
		biosig.o \
		tinyxml.o \
		tinyxmlparser.o \
		tinyxmlerror.o \
		tinystr.o \
		sopen_scp_read.o \
		sopen_alpha_read.o \
		sopen_scp_write.o \
		sopen_hl7aecg.o \
		biosig-network.o \
		sandbox.o \

MinGWOBJECTS  = \
		win32/crc4scp.obj \
		win32/biosig.obj \
		win32/getlogin_r.obj \
		win32/tinyxml.obj \
		win32/tinyxmlparser.obj \
		win32/tinyxmlerror.obj \
		win32/tinystr.obj \
		win32/sopen_scp_read.obj \
		win32/sopen_alpha_read.obj \
		win32/sopen_scp_write.obj \
		win32/sopen_hl7aecg.obj \
		win32/biosig-network.obj \
		win32/sandbox.obj \

ifneq (,$(findstring WITH_FAMOS, $(DEFINES)))
  OBJECTS      += sopen_famos_read.o
endif
ifneq (,$(findstring WITH_FAMOS, $(MinGWDEF)))
  MinGWOBJECTS += win32/sopen_famos_read.obj
endif
ifneq (,$(findstring WITH_FEF, $(DEFINES)))
  OBJECTS      += sopen_fef_read.o
endif
ifneq (,$(findstring WITH_FEF, $(MinGWDEF)))
  MinGWOBJECTS += win32/sopen_fef_read.obj
endif
ifeq (,$(findstring WITHOUT_SCP_DECODE, $(DEFINES)))
  OBJECTS      += scp-decode.o
endif
ifeq (,$(findstring WITHOUT_SCP_DECODE, $(MinGWDEF)))
  MinGWOBJECTS += win32/scp-decode.obj
endif

MinGW64OBJECTS  = $(patsubst win32/%.obj, win64/%.obj, $(MinGWOBJECTS))

TARGET = save2gdf 

first: $(TARGET)
all:   $(TARGET) mex4o biosig4python win32 biosig_client biosig_server mma java tcl perl php ruby #sigviewer 
lib:	libbiosig.a win32/libbiosig.dll win32/libbiosig.a

#############################################################
#	Compilation: Implicit, default rules
#############################################################

.SUFFIXES: .o .c .cpp .cc .cxx .C

.cpp.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.cc.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.cxx.o:
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.C.o:
	$(CC) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"
.c.o:
	$(CC) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

%.o: %.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t210/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t220/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t230/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: t240/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
%.o: test0/%.c biosig.h biosig-dev.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"
%.o: XMLParser/%.cpp
	$(CXX) -c $(CXXFLAGS) $(INCPATH) -o "$@" "$<"

win32/%.obj: %.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t210/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t220/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t230/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"
win32/%.obj: t240/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win32/%.obj: test0/%.c  biosig-dev.h biosig.h 
	$(MinGWCC) -c $(MinGWCFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win32/%.obj: XMLParser/%.cpp 
	$(MinGWCXX) -c $(MinGWCFLAGS) $(INCPATH) -o "$@" "$<"

win64/%.obj: %.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) $(INCPATH) -o "$@" "$<"
win64/%.obj: t210/%.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) $(INCPATH) -o "$@" "$<"
win64/%.obj: t220/%.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) $(INCPATH) -o "$@" "$<"
win64/%.obj: t230/%.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) $(INCPATH) -o "$@" "$<"
win64/%.obj: t240/%.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win64/%.obj: test0/%.c  biosig-dev.h biosig.h 
	$(MinGW64CC) -c $(MinGW64CFLAGS) -I t240 $(INCPATH) -o "$@" "$<"
win64/%.obj: XMLParser/%.cpp 
	$(MinGW64CXX) -c $(MinGW64CFLAGS) $(INCPATH) -o "$@" "$<"


#############################################################
#	event table: conversion from ascii to C code
#############################################################

biosig.c: eventcodes.i

eventcodes.i : ../biosig/doc/eventcodes.txt
	cat "$<" | awk "-F\t" '/^[^#]/ {print "\t"$$1", \""$$2,"\","}' > eventcodes.i


#############################################################
#	generate libGDF.a
#############################################################

%.o : ../libgdf/libgdf/src/%.cpp
	$(CXX) -I../libgdf/libgdf/include -c "$<" -o "$@"

libGDF.a: $(libGDFobj)
	-$(DELETE) "$@"
	$(AR) "$@" $(libGDFobj)

win32/%.obj : ../libgdf/libgdf/src/%.cpp
	$(CROSS)$(CXX) -I../libgdf/libgdf/include -c "$<" -o "$@"

win32/libGDF.a: $(libGDFwin32obj)
	-$(DELETE) "$@"
	$(CROSS)$(AR) "$@" $(libGDFwin32obj)


win64/%.obj : ../libgdf/libgdf/src/%.cpp
	$(CROSS64)$(CXX) -I../libgdf/libgdf/include -c "$<" -o "$@"

win64/libGDF.a: $(libGDFwin64obj)
	-$(DELETE) "$@"
	$(CROSS64)$(AR) "$@" $(libGDFwin64obj)


#############################################################
#	Compilation: exceptions, explicit rules
#############################################################

sopen_fef_read.o: t240/sopen_fef_read.c biosig-dev.h biosig.h
#	cd t240
#	#asn1c -fcompound-names -pdu=SessionArchiveSection -S /home/schloegl/cvs/asn1c/skeletons fef.asn1
#	asn1c -fcompound-names -pdu=SessionArchiveSection fef.asn1
#	#asn1c -fcompound-names iso11073-10471.asn1
#	#asn1c -fcompound-names iso11073-20601.asn1
#	cd ..
#	make -C t240 -f Makefile.am.sample
	$(CC) -c $(CFLAGS) -I t240 $(INCPATH) -o "$@" "$<"

sopen_hl7aecg.o: t230/sopen_hl7aecg.c biosig-dev.h biosig.h XMLParser/tinyxml.h XMLParser/tinystr.h
	$(CXX) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"

sopen_scp_read.o: t210/sopen_scp_read.c biosig-dev.h biosig.h biosig.h t210/structures.h
	$(CXX) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"

scp-decode.o: t210/scp-decode.cpp biosig-dev.h biosig.h t210/structures.h t210/codes.h
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"

getlogin_r.o: win32/getlogin_r.c
	$(CC) -c $(CFLAGS) $(INCPATH) -o "$@" "$<"

=== mex/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2600 2011-02-03 00:13:06Z schloegl $
###  Copyright (C) 2006,2007,2008,2009 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


PathToMinGW   = $(HOME)/src/mingw-cross-env
PathToMinGW64 = $(HOME)/src/mce-w64
### modify directories according to your needs 
INCOCTAVE = -I /usr/include/octave 
MATLABDIR = /usr/local/MATLAB/R2010b/
# comment the following line if you use MATLAB on 32-bit operating system
MEX_OPTION += -largeArrayDims
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
LIBEXT        = a
#LIBEXT	      = so
# 
# WIN32 settings: 
# Mingw crosscompiler: available at http://www.nongnu.org/mingw-cross-env/
# whether dynamic or static linking is used, can be controlled with 
CROSS   = $(PathToMinGW)/usr/bin/i686-pc-mingw32-
CROSS64 = $(PathToMinGW64)/usr/bin/x86_64-w64-mingw32-
# include directory for Win32-Matlab include
W32MAT_INC = $(HOME)/bin/win32/Matlab/R2010b/extern/include/
W64MAT_INC = $(HOME)/bin/win64/Matlab/R2010b/extern/include/
# path to GNUMEX libraries, available from here http://sourceforge.net/projects/gnumex/
GNUMEX   = $(HOME)/bin/win32/gnumex
GNUMEX64 = $(HOME)/bin/win64/gnumex
###############################


### User-specified options: its likely you want to change this
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
LIBS          = -lbiosig -lz -lcholmod
LFLAGS        = -L..
COPY          = cp

mex: mex4m mex4o 
win32 win mexw32: mexSLOAD.mexw32 mexSOPEN.mexw32 
win64 mexw64: mexSLOAD.mexw64 mexSOPEN.mexw64 
all: mex4m mex4o win32 win64

clean:
	-$(RM) *.o *.obj *.o64 core octave-core *.oct *~ *.mex* 

##########################################################
## set Matlab and Octave variables
ifneq ($(shell which matlab), )
  MATLABDIR  := $(dir $(shell readlink -f $(shell which matlab) ) )
  MEX         = $(MATLABDIR)mex
  MEX_EXT    := $(shell $(MATLABDIR)mexext)
endif

# Octave - local install (e.g. compiled from sources) 
OCTAVE_VERSION 	= -3.4.0
INCOCTAVE 	= -I /usr/local/include/octave$(OCTAVE_VERSION)/octave 
# Octave - global install  (e.g. from debian package)
#OCTAVE_VERSION 	= 
#INCOCTAVE 	= -I /usr/include/octave 

OCT           	= mkoctfile$(OCTAVE_VERSION)
##########################################################

../libbiosig.$(LIBEXT):
	make -C .. libbiosig.$(LIBEXT)

../win32/libbiosig.a:
	make -C .. win32/libbiosig.a

#############################################################
#	MEX-Interface for Octave and Matlab
#############################################################
mex: mex4m mex4o
ifneq ($(shell which matlab), )
mex4m: mexSLOAD.$(MEX_EXT) mexSOPEN.$(MEX_EXT)
mexSLOAD: mexSLOAD.$(MEX_EXT) 
mexSOPEN: mexSOPEN.$(MEX_EXT)
mexSLOAD.$(MEX_EXT): mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(MEX) $(MEX_OPTION) $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS)
	-$(COPY) mexSLOAD.$(MEX_EXT) ../../biosig/t200_FileAccess/
mexSOPEN.$(MEX_EXT): mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(MEX) $(MEX_OPTION) -DmexSOPEN $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS) -output mexSOPEN
	-$(COPY) mexSOPEN.$(MEX_EXT) ../../biosig/t200_FileAccess/
endif



### MEX-files for Octave
mex4o:  mexSLOAD.mex mexSOPEN.mex
mexSLOAD.mex:  mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT)  $(DEFINES) -v -g --mex mexSLOAD.cpp $(LFLAGS) $(LIBS)
	-$(COPY) mexSLOAD.mex ../../biosig/t200_FileAccess/
mexSOPEN.mex:  mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT) -D=mexSOPEN $(DEFINES) -v -g --mex mexSLOAD.cpp $(LFLAGS) $(LIBS) -o mexSOPEN.mex
	-$(COPY) mexSOPEN.mex ../../biosig/t200_FileAccess/
#physicalunits.mex:  physicalunits.cpp libbiosig.$(LIBEXT)
#	$(OCT) -v -g --mex physicalunits.cpp $(LFLAGS) $(LIBS)

oct:  mexSLOAD.oct
mexSLOAD.oct:  mexSLOAD.cpp ../libbiosig.$(LIBEXT) Makefile
	$(OCT)  $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS)
	$(OCT) -D=mexSOPEN $(DEFINES) mexSLOAD.cpp $(LFLAGS) $(LIBS) -o mexSOPEN.oct
	-$(COPY) mexSOPEN.oct ../../biosig/t200_FileAccess/
	-$(COPY) mexSOPEN.oct ../../biosig/t200_FileAccess/


#########################################################
#	MATLAB/WIN32
#########################################################
%.obj: %.cpp
	$(CROSS)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O3 -DMX_COMPAT_32 $< 
%.obj: %.c
	$(CROSS)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W32MAT_INC) -O3 -DMX_COMPAT_32 $< 

mexSOPEN.obj: mexSLOAD.cpp
	$(CROSS)$(CXX) -c -DMATLAB_MEX_FILE -D=mexSOPEN -x c++ -o $@ -I$(W32MAT_INC) -O3 -DMX_COMPAT_32 $< 

%.mexw32: %.obj ../win32/libbiosig.a
	$(CROSS)$(CXX) -shared $(GNUMEX)/mex.def -o $@ -L$(GNUMEX) -s $< -llibmx -llibmex ../win32/libbiosig.a -lz -lcholmod -lws2_32


#########################################################
#	MATLAB/WIN64
#########################################################
%.o64: %.cpp
	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O3 -DMX_COMPAT_64 $< 
%.o64: %.c
	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -x c++ -o $@ -I$(W64MAT_INC) -O3 -DMX_COMPAT_64 $< 

mexSOPEN.o64: mexSLOAD.cpp
	$(CROSS64)$(CXX) -c -DMATLAB_MEX_FILE -D=mexSOPEN -x c++ -o $@ -I$(W64MAT_INC) -O3 -DMX_COMPAT_64 $< 

%.mexw64: %.o64 ../win64/libbiosig.a
	$(CROSS64)$(CXX) -shared $(GNUMEX64)/mex.def -o $@ -L$(GNUMEX64) -s $< -llibmx -llibmex ../win64/libbiosig.a -lz -lcholmod -lws2_32

=== mma/Makefile ===
# Makefile to compile sload.exe for loading data supported by libbiosig into Mathematica
# Copyright (C) 2010, 2011 Alois Schloegl

###########################################
# user-defined variables 
########################################### 
##########################################################
## set Mathematica variables
MLINKDIR  = /usr/local/Wolfram/gridMathematicaServer/7.0/SystemFiles/Links/MathLink/DeveloperKit
ifneq ($(shell which mathematica), )
  MLINKDIR  := $(dir $(shell readlink -f $(shell which mathematica) ) )../SystemFiles/Links/MathLink/DeveloperKit
endif
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
MLLIB     = ML64i3 # ML32i3 # Set this to ML64i3 if using a 64-bit system
#
# Windows
#MLINKDIR  = /usr/local/Wolfram/gridMathematicaServer/7.0/SystemFiles/Links/MathLink/DeveloperKit
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i3m# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/${SYS}/CompilerAdditions
INCDIR    = ${CADDSDIR}
LIBDIR    = ${CADDSDIR}

EXTRALIBS = -lm -lpthread -lrt -lstdc++ -lcholmod -lz -L.. -lbiosig# Set these with appropriate libs for your system.

MPREP     = ${CADDSDIR}/mprep

all : sload sload.exe
win win32 : sload.exe

../libbiosig.a:
	make -C .. libbiosig.a

../win32/libbiosig.a: 
	make -C .. win32/libbiosig.a

.c.o :
	${CC} -c -I${INCDIR} $<

sloadtm.c : sload.tm
	${MPREP} $? -o $@

sload : sload.o sloadtm.o ../libbiosig.a
	${CC} sloadtm.o sload.o -L${LIBDIR} -l${MLLIB} ${EXTRALIBS} -o $@


###########################################
#   Windows - cross-compilation 
###########################################


CCwin        = $(HOME)/R/src/mingw-cross-env/usr/bin/i686-pc-mingw32-gcc
CADDSDIRwin  = ${MLINKDIR}/${SYSwin}/CompilerAdditions/mldev32
INCDIRwin    = ${CADDSDIRwin}/include
LIBDIRwin    = ${CADDSDIRwin}/lib

EXTRALIBSwin =  ../win32/libbiosig.a -lgdi32 -lm -lpthread -lstdc++ -lws2_32 -lcholmod -lz  # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/bin/mprep

sloadtm.win32.c : sload.tm
	wine ${MPREPwin} $? -o $@

sload.obj : sload.c
	${CCwin} -c -I${INCDIRwin} $< -o $@
sloadtm.obj : sloadtm.win32.c
	${CCwin} -c -I${INCDIRwin} $< -o $@

sload.exe : sload.obj sloadtm.obj ../win32/libbiosig.a
	${CCwin} sload.obj sloadtm.obj -static-libgcc -static-libstdc++ -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o $@

	
###########################################
clean:
	-$(RM) *.o
	-$(RM) *.obj
	-$(RM) *tm.c
	-$(RM) sload.exe
	-$(RM) sload

=== python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile,v 1.72 2009/03/03 11:46:57 schloegl Exp $
###  Copyright (C) 2006,2007,2008,2009 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################

CXX           = g++
DEFINES       = -D=WITH_ZLIB -D=WITH_CHOLMOD -D=__4HAERTEL__ -D=WITH_FAMOS #-D=WITH_FEF -D=WITH_DICOM #-D=WITH_GDCM #-D=WITH_GSL #-D=WITH_EEPROBE #-D=SOFTCODED_PHYSDIMTABLE # if you have zlib
CXXFLAGS      =  -pipe -fPIC -Wall -O2 -Wextra $(DEFINES) # -I cntopenlib/include/
LIBS          = ../libbiosig.a -lz -lcholmod # t240/libfef.a #-lgdcmDSED -lgsl -lgslcblas -lm	# static
SWIG          = swig
# To allow using arbitrary python
PYTHON		  = python
PYTHONVER     = $(shell $(PYTHON) -c "import sys; print sys.version[:3]")
# rely on numpy.distutils to get includes' path, which might carry
# per-Python version specific settings (e.g. _numpyconfig.h)
PYTHON_INC    = $(shell $(PYTHON) -c 'import numpy.distutils.system_info as si; print " -I".join(si.numpy_info().get_include_dirs())')
NUMPY_INC     = $(shell $(PYTHON) -c 'import numpy.distutils.misc_util as mu; print " -I".join(mu.get_numpy_include_dirs())')
DEL_FILE      = rm
COPY          = cp -f

TARGET = biosig4python
first: $(TARGET)

../libbiosig.a:
	make -C .. libbiosig.a

biosig4python: _biosig.so biosig.py
biosig.py swig_wrap.cxx: ../libbiosig.a swig.i 
	$(SWIG) -c++ -python -I/usr/include -I$(NUMPY_INC) -o swig_wrap.cxx swig.i

_biosig.so : swig_wrap.cxx 
	$(CXX) -c $(CXXFLAGS) swig_wrap.cxx -o swig_wrap.o -I$(PYTHON_INC) -I$(NUMPY_INC) && \
	$(CXX) -shared swig_wrap.o $(LIBS) -o _biosig.so

test: /tmp/BDFtestfiles.zip biosig4python
	unzip -u /tmp/BDFtestfiles.zip -d /tmp && \
	$(PYTHON) demo.py /tmp/*-256.bdf
	$(PYTHON) example.py /tmp/*-256.bdf 256 && \
	$(PYTHON) example.py /tmp/*-2048.bdf 2048

/tmp/BDFtestfiles.zip :
	wget -P/tmp http://www.biosemi.com/download/BDFtestfiles.zip


clean:
	-$(DEL_FILE) biosig.py*
	-$(DEL_FILE) swig_wrap.*
	 
.PHONY: first biosig4python clean test

=== t240/Makefile ===
ASN_MODULE_SOURCES=	\
	Address.c	\
	MetricMeasure.c	\
	UnitCode.c	\
	HealthCareProviderId.c	\
	INT-U64.c	\
	INT-I64.c	\
	INT-U32.c	\
	INT-I32.c	\
	INT-U16.c	\
	INT-I16.c	\
	INT-U8.c	\
	INT-I8.c	\
	BITS-32.c	\
	BITS-16.c	\
	BITS-8.c	\
	FEFString.c	\
	FEFFloat.c	\
	Fraction.c	\
	AbsoluteRange.c	\
	Handle.c	\
	HandleRef.c	\
	DeviceCode.c	\
	UnitsOfMeasurementCode.c	\
	MetricsCode.c	\
	BodySiteCode.c	\
	AlertCode.c	\
	ExtNomenclatureCode.c	\
	ParameterGroupCode.c	\
	PrivateCode.c	\
	Placeholder.c	\
	ManufacturerID.c	\
	AbsoluteTime.c	\
	RelativeTime.c	\
	HighResRelativeTime.c	\
	ObservationTime.c	\
	SimpleColour.c	\
	ExtNomenRef.c	\
	PersonNameGroup.c	\
	PersonName.c	\
	OID-Type.c	\
	SessionArchiveSection.c	\
	ArchiveProtection.c	\
	ManufacturerSpecificSection.c	\
	ManufacturerSpecificEncoded.c	\
	ManufacturerSpecificBinary.c	\
	HealthCareProviderSection.c	\
	HealthCareProfessionalSection.c	\
	Authorization.c	\
	PatientDemographicsSection.c	\
	PatMeasure.c	\
	PatientSex.c	\
	PatientType.c	\
	PatientRace.c	\
	SessionTestSection.c	\
	MedicalDeviceSystemSection.c	\
	SystemModel.c	\
	SystemSpecEntry.c	\
	ProdSpecEntryType.c	\
	ProdSpecEntry.c	\
	ApplicationArea.c	\
	PowerStatus.c	\
	LineFrequency.c	\
	MedicalDeviceComponents.c	\
	VirtualMedicalDeviceSection.c	\
	MsmtPrinciple.c	\
	ChannelDescriptionSection.c	\
	ChannelStatus.c	\
	MultimediaSection.c	\
	Comments.c	\
	ContentOrReference.c	\
	SessionPhaseSection.c	\
	DescriptiveDataSection.c	\
	MetricDescriptiveDataSection.c	\
	MetricStatus.c	\
	MetricCategory.c	\
	MetricCalEntry.c	\
	MetricCalType.c	\
	MetricCalState.c	\
	MeasurementStatus.c	\
	SampleArrayDescriptiveDataSection.c	\
	SaSpec.c	\
	StorageDataType.c	\
	SaFlags.c	\
	ScaleRangeSpec.c	\
	SaFilterEntry.c	\
	FilterType.c	\
	SaGridEntry.c	\
	SaCalData.c	\
	SaCalDataType.c	\
	SaSignalFrequency.c	\
	RealTimeSampleArrayDescriptiveDataSection.c	\
	TimeSampleArrayDescriptiveDataSection.c	\
	DistributionSampleArrayDescriptiveDataSection.c	\
	DsaRangeSpec.c	\
	NumericDescriptiveDataSection.c	\
	EnumerationDescriptiveDataSection.c	\
	MeasuredDataSection.c	\
	SampleArrayMeasuredDataSection.c	\
	SampleArrayMeasuredDataBlock.c	\
	RealTimeSampleArrayMeasuredDataSection.c	\
	TimeSampleArrayMeasuredDataSection.c	\
	MarkerEntryRelTim.c	\
	DistributionSampleArrayMeasuredDataSection.c	\
	NumericMeasuredDataSection.c	\
	ChoiceOfNuObsValue.c	\
	NuObsValue.c	\
	DispResolution.c	\
	EnumerationMeasuredDataSection.c	\
	ChoiceOfEnumObsValue.c	\
	EnumObsValue.c	\
	EnumVal.c	\
	EnumObject.c	\
	EnumRecordMetric.c	\
	EnumRecordOO.c	\
	ChoiceOfEnumTimeStamp.c	\
	AlertSection.c	\
	AlertCondition.c	\
	AlertControls.c	\
	AlertFlags.c	\
	AlertType.c	\
	LimitSpecEntry.c	\
	CurLimAlStat.c	\
	DynamicAttributeChangeSection.c	\
	SessionNotesSection.c

ASN_MODULE_HEADERS=	\
	Address.h	\
	MetricMeasure.h	\
	UnitCode.h	\
	HealthCareProviderId.h	\
	INT-U64.h	\
	INT-I64.h	\
	INT-U32.h	\
	INT-I32.h	\
	INT-U16.h	\
	INT-I16.h	\
	INT-U8.h	\
	INT-I8.h	\
	BITS-32.h	\
	BITS-16.h	\
	BITS-8.h	\
	FEFString.h	\
	FEFFloat.h	\
	Fraction.h	\
	AbsoluteRange.h	\
	Handle.h	\
	HandleRef.h	\
	DeviceCode.h	\
	UnitsOfMeasurementCode.h	\
	MetricsCode.h	\
	BodySiteCode.h	\
	AlertCode.h	\
	ExtNomenclatureCode.h	\
	ParameterGroupCode.h	\
	PrivateCode.h	\
	Placeholder.h	\
	ManufacturerID.h	\
	AbsoluteTime.h	\
	RelativeTime.h	\
	HighResRelativeTime.h	\
	ObservationTime.h	\
	SimpleColour.h	\
	ExtNomenRef.h	\
	PersonNameGroup.h	\
	PersonName.h	\
	OID-Type.h	\
	SessionArchiveSection.h	\
	ArchiveProtection.h	\
	ManufacturerSpecificSection.h	\
	ManufacturerSpecificEncoded.h	\
	ManufacturerSpecificBinary.h	\
	HealthCareProviderSection.h	\
	HealthCareProfessionalSection.h	\
	Authorization.h	\
	PatientDemographicsSection.h	\
	PatMeasure.h	\
	PatientSex.h	\
	PatientType.h	\
	PatientRace.h	\
	SessionTestSection.h	\
	MedicalDeviceSystemSection.h	\
	SystemModel.h	\
	SystemSpecEntry.h	\
	ProdSpecEntryType.h	\
	ProdSpecEntry.h	\
	ApplicationArea.h	\
	PowerStatus.h	\
	LineFrequency.h	\
	MedicalDeviceComponents.h	\
	VirtualMedicalDeviceSection.h	\
	MsmtPrinciple.h	\
	ChannelDescriptionSection.h	\
	ChannelStatus.h	\
	MultimediaSection.h	\
	Comments.h	\
	ContentOrReference.h	\
	SessionPhaseSection.h	\
	DescriptiveDataSection.h	\
	MetricDescriptiveDataSection.h	\
	MetricStatus.h	\
	MetricCategory.h	\
	MetricCalEntry.h	\
	MetricCalType.h	\
	MetricCalState.h	\
	MeasurementStatus.h	\
	SampleArrayDescriptiveDataSection.h	\
	SaSpec.h	\
	StorageDataType.h	\
	SaFlags.h	\
	ScaleRangeSpec.h	\
	SaFilterEntry.h	\
	FilterType.h	\
	SaGridEntry.h	\
	SaCalData.h	\
	SaCalDataType.h	\
	SaSignalFrequency.h	\
	RealTimeSampleArrayDescriptiveDataSection.h	\
	TimeSampleArrayDescriptiveDataSection.h	\
	DistributionSampleArrayDescriptiveDataSection.h	\
	DsaRangeSpec.h	\
	NumericDescriptiveDataSection.h	\
	EnumerationDescriptiveDataSection.h	\
	MeasuredDataSection.h	\
	SampleArrayMeasuredDataSection.h	\
	SampleArrayMeasuredDataBlock.h	\
	RealTimeSampleArrayMeasuredDataSection.h	\
	TimeSampleArrayMeasuredDataSection.h	\
	MarkerEntryRelTim.h	\
	DistributionSampleArrayMeasuredDataSection.h	\
	NumericMeasuredDataSection.h	\
	ChoiceOfNuObsValue.h	\
	NuObsValue.h	\
	DispResolution.h	\
	EnumerationMeasuredDataSection.h	\
	ChoiceOfEnumObsValue.h	\
	EnumObsValue.h	\
	EnumVal.h	\
	EnumObject.h	\
	EnumRecordMetric.h	\
	EnumRecordOO.h	\
	ChoiceOfEnumTimeStamp.h	\
	AlertSection.h	\
	AlertCondition.h	\
	AlertControls.h	\
	AlertFlags.h	\
	AlertType.h	\
	LimitSpecEntry.h	\
	CurLimAlStat.h	\
	DynamicAttributeChangeSection.h	\
	SessionNotesSection.h

ASN_MODULE_HEADERS+=ANY.h
ASN_MODULE_SOURCES+=ANY.c
ASN_MODULE_HEADERS+=UTF8String.h
ASN_MODULE_HEADERS+=INTEGER.h
ASN_MODULE_HEADERS+=NativeEnumerated.h
ASN_MODULE_HEADERS+=GeneralizedTime.h
ASN_MODULE_SOURCES+=GeneralizedTime.c
ASN_MODULE_SOURCES+=INTEGER.c
ASN_MODULE_SOURCES+=NativeEnumerated.c
ASN_MODULE_HEADERS+=NativeInteger.h
ASN_MODULE_SOURCES+=NativeInteger.c
ASN_MODULE_HEADERS+=REAL.h
ASN_MODULE_HEADERS+=OBJECT_IDENTIFIER.h
ASN_MODULE_SOURCES+=OBJECT_IDENTIFIER.c
ASN_MODULE_SOURCES+=REAL.c
ASN_MODULE_SOURCES+=UTF8String.c
ASN_MODULE_HEADERS+=asn_SEQUENCE_OF.h
ASN_MODULE_SOURCES+=asn_SEQUENCE_OF.c
ASN_MODULE_HEADERS+=asn_SET_OF.h
ASN_MODULE_SOURCES+=asn_SET_OF.c
ASN_MODULE_HEADERS+=constr_CHOICE.h
ASN_MODULE_SOURCES+=constr_CHOICE.c
ASN_MODULE_HEADERS+=constr_SEQUENCE.h
ASN_MODULE_SOURCES+=constr_SEQUENCE.c
ASN_MODULE_HEADERS+=constr_SEQUENCE_OF.h
ASN_MODULE_SOURCES+=constr_SEQUENCE_OF.c
ASN_MODULE_HEADERS+=constr_SET_OF.h
ASN_MODULE_SOURCES+=constr_SET_OF.c
ASN_MODULE_HEADERS+=asn_application.h
ASN_MODULE_HEADERS+=asn_system.h
ASN_MODULE_HEADERS+=asn_codecs.h
ASN_MODULE_HEADERS+=asn_internal.h
ASN_MODULE_HEADERS+=OCTET_STRING.h
ASN_MODULE_SOURCES+=OCTET_STRING.c
ASN_MODULE_HEADERS+=BIT_STRING.h
ASN_MODULE_SOURCES+=BIT_STRING.c
ASN_MODULE_SOURCES+=asn_codecs_prim.c
ASN_MODULE_HEADERS+=asn_codecs_prim.h
ASN_MODULE_HEADERS+=ber_tlv_length.h
ASN_MODULE_SOURCES+=ber_tlv_length.c
ASN_MODULE_HEADERS+=ber_tlv_tag.h
ASN_MODULE_SOURCES+=ber_tlv_tag.c
ASN_MODULE_HEADERS+=ber_decoder.h
ASN_MODULE_SOURCES+=ber_decoder.c
ASN_MODULE_HEADERS+=constr_TYPE.h
ASN_MODULE_SOURCES+=constr_TYPE.c
ASN_MODULE_HEADERS+=constraints.h
ASN_MODULE_SOURCES+=constraints.c
ASN_MODULE_HEADERS+=der_encoder.h
ASN_MODULE_SOURCES+=der_encoder.c
ASN_MODULE_HEADERS+=xer_support.h
ASN_MODULE_SOURCES+=xer_support.c
ASN_MODULE_HEADERS+=xer_decoder.h
ASN_MODULE_SOURCES+=xer_decoder.c
ASN_MODULE_HEADERS+=xer_encoder.h
ASN_MODULE_SOURCES+=xer_encoder.c
ASN_MODULE_HEADERS+=per_opentype.h
ASN_MODULE_SOURCES+=per_opentype.c
ASN_MODULE_HEADERS+=per_support.h
ASN_MODULE_SOURCES+=per_support.c
ASN_MODULE_HEADERS+=per_decoder.h
ASN_MODULE_SOURCES+=per_decoder.c
ASN_MODULE_HEADERS+=per_encoder.h
ASN_MODULE_SOURCES+=per_encoder.c
#ASN_CONVERTER_SOURCES+=converter-sample.c



lib_LTLIBRARIES=libsomething.la
libsomething_la_SOURCES=$(ASN_MODULE_SOURCES) $(ASN_MODULE_HEADERS)

# This file may be used as an input for make(3)
# Remove the lines below to convert it into a pure .am file
WIN32  = ../win32/libcnsfef.a ../win32/libcnsfef.dll
TARGET = libcnsfef.a $(WIN32)
CFLAGS += -pipe -fPIC -Wall -O2 -Wextra  -I.
OBJS=${ASN_MODULE_SOURCES:.c=.o} ${ASN_CONVERTER_SOURCES:.c=.o}
WINOBJS=${ASN_MODULE_SOURCES:.c=.obj} ${ASN_CONVERTER_SOURCES:.c=.obj}
W64OBJS=${ASN_MODULE_SOURCES:.c=.o64} ${ASN_CONVERTER_SOURCES:.c=.o64}

CC        = gcc
AR        = ar crs
MinGWCC   = $(CROSS)gcc 
AR64      = amd64-mingw32msvc-ar 
MinGW64CC = amd64-mingw32msvc-gcc 

all: $(TARGET)

#$(TARGET): ${OBJS}
#	$(CC) $(CFLAGS) -o $(TARGET) ${OBJS} $(LDFLAGS) $(LIBS)

libcnsfef.a: $(OBJS) 
	$(AR) libcnsfef.a $(OBJS) 

../win32/libcnsfef.a: $(WINOBJS) 
	$(CROSS)$(AR) ../win32/libcnsfef.a $(WINOBJS) 

../win64/libcnsfef.a: $(W64OBJS) 
	$(AR64) ../win64/libcnsfef.a $(W64OBJS) 

../win32/libcnsfef.dll: $(WINOBJS)
	$(MinGWCC) -shared -fPIC  $(WINOBJS)  -Wl,--output-def,../win32/libcnsfef.def,--out-implib,../win32/libcnsfef.dll

../win64/libcnsfef.dll: $(WINOBJS)
	$(MinGW64CC) -shared -fPIC  $(W64OBJS)  -Wl,--output-def,../win64/libcnsfef.def,--out-implib,../win64/libcnsfef.dll


.SUFFIXES:
.SUFFIXES: .c .o

%.obj: %.c
	$(CROSS)$(CC) $(CFLAGS) -o $@ -c $<

.c.o:
	$(CC) $(CFLAGS) -o $@ -c $<

clean:
#	rm -f $(ASN_MODULE_HEADERS)
#	rm -f $(ASN_MODULE_SOURCES)
	rm -f $(TARGET)
	rm -f $(OBJS)
	rm -f $(WINOBJS)
	rm -f Makefile.am.sample libfef.a 

regen: regenerate-from-asn1-source 

regenerate-from-asn1-source:
	asn1c -fcompound-names ../annexb-snacc-122001.asn1 
	rm -f converter-sample.c Makefile.am.sample libfef.a

=== debian/changelog ===
biosig4c++ (0.96.3+svn2677-2) unstable; urgency=low

  * up_for_loop_initial patch to prevent FTBFS. Thanks Aurelien Jarno for
    report and patch (Closes: #633346)

 -- Yaroslav Halchenko <debian@onerussian.com>  Sat, 09 Jul 2011 10:40:56 -0400

biosig4c++ (0.96.3+svn2677-1) unstable; urgency=low

  * Initial release (Closes: #585533)
  * Ship and use a copy of eventcodes.txt from biosig project
  * Patches added:
    - up_system_octave_version to build against default available
      version of octave
    - deb_no_mex_copy_upstairs to not try copy resultant .mex files
      outside of the tree
    - deb_link_dynamically* to assure dynamic linking against the library
    - deb_no_locals to avoid errorneous linking against /usr/local

 -- Yaroslav Halchenko <debian@onerussian.com>  Thu, 05 May 2011 12:28:27 -0400

biosig4c++ (0.94.2+svn2552-1~pre1) UNRELEASED; urgency=low

  * New upstream snapshot: some API extensions in the library interface
  * Assure linking of .so against used libraries
  * Symlinks for the missing manpages

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 29 Oct 2010 00:58:54 -0400

biosig4c++ (0.94.1+svn2521-1~pre0) UNRELEASED; urgency=low

  * Initial Debian packaging.

 -- Yaroslav Halchenko <debian@onerussian.com>  Fri, 11 Jun 2010 01:19:48 -0400

=== debian/control ===
Source: biosig4c++
Priority: extra
Maintainer: NeuroDebian Team <team@neuro.debian.net>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 7.0.50~),
			   python-dev, python-support, swig, python-numpy,
			   zlib1g-dev, libsuitesparse-dev,
			   octave-pkg-dev (>= 0.5.7),
Standards-Version: 3.9.2
Section: science
Homepage: http://biosig.sf.net/
Vcs-Git: git://git.debian.org/pkg-exppsy/biosig4c--.git
Vcs-Browser: http://git.debian.org/?p=pkg-exppsy/biosig4c--.git;a=summary

Package: libbiosig0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig0-dbg
Section: debug
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libbiosig0 (= ${binary:Version})
Description: I/O library for biomedical data - debug symbols
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides debug symbols.

Package: libbiosig-dev
Section: libdevel
Architecture: any
Depends: libbiosig0 (= ${binary:Version}), ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Section: science
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
    not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF, BDF,
    CWFB.  save2gdf can be also used to upload or retrieve data from a
    bscs server.

Package: python-biosig
Section: python
Architecture: any
Depends: ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: Python bindings for BioSig library
 This package provides Python bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Depends: ${octave:Depeds}, ${shlibs:Depends}, ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh  $@

override_dh_auto_build:
	: # Build everything upstream builds by default
	make
	: # Assure additional interesting to us pieces are built
	make mex4o biosig4python biosig_client biosig_server
	#make libbiosig.a save2gdf save2aecg save2scp pdp2gdf \
	#	 biosig_client biosig_server
	# Later: libbiosig.so -- fails, no SONAME etc,
	#         mex4o -- there are some copying etc
	# Later: Python -- depends on obsolete Numeric
	#        biosig4python 
	#  to build for multiple Python's would need to loop
	#  between versions with smth like make python -B PYTHONVER=2.6

override_dh_auto_test:
	: I: skip testing for now -- relies on download of test data

# Manual crafting of installing Octave and Python bindings
# TODO: proper
PYTHON=$(shell pyversions -d)
PYDIR=$(shell /bin/ls -d /usr/lib/$(PYTHON)/*-packages)

OCTDIR=$(shell octave-config --oct-site-dir)

override_dh_auto_install:
	dh_auto_install

	: I: install Python binding for current Python verion TODO: all
	mkdir -p debian/python-biosig$(PYDIR)
	install -m 0644 python/biosig.py python/_biosig.so debian/python-biosig$(PYDIR)

	: I: install Octave bindings
	mkdir -p debian/octave-biosig$(OCTDIR)
	: # install with executable flag so dh_{strip,...} tools could catch it to operate
	install mex/mexS*.mex debian/octave-biosig$(OCTDIR)
	[ -e /usr/bin/octave-depends ] && octave-depends

override_dh_strip:
	dh_strip --dbg-package=libbiosig0-dbg
	: # Address lintian concern about location
	[ -d debian/libbiosig0-dbg/usr/lib/debug/usr/lib/pyshared ] && \
		mv debian/libbiosig0-dbg/usr/lib/debug/usr/lib/pyshared \
		   debian/libbiosig0-dbg/usr/lib/debug/usr/lib/pymodules || :

# Tune up permission for .mex files this late in the chain
# Silly dh_strip, dh_shlibdeps do not process those since extension
# is "unknown" to them and they are not executable
override_dh_gencontrol:
	chmod a-x debian/octave-biosig$(OCTDIR)/*.mex
	dh_gencontrol

override_dh_auto_clean:
	dh_auto_clean
	make clean					# distclean invoked by auto isn't enough
